---
title: llarp::layers::flow::FlowInfo
summary: information about our flow identity. 

---

# llarp::layers::flow::FlowInfo



information about our flow identity.  [More...](#detailed-description)


`#include <flow_info.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| std::string | **[ToString](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#function-tostring)**() const |
| bool | **[operator==](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#function-operator==)**(const [FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) & other) const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) | **[src](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-src)** <br>source and destination addresses we associate with this flow.  |
| [FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) | **[dst](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-dst)**  |
| std::set< [FlowTag](Classes/structllarp_1_1layers_1_1flow_1_1FlowTag.md) > | **[flow_tags](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-flow-tags)** <br>to be replaced by a std::optional<FlowTag>.  |
| uint16_t | **[mtu](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-mtu)** <br>mtu between src and dst.  |

## Detailed Description

```cpp
struct llarp::layers::flow::FlowInfo;
```

information about our flow identity. 

in lokinet our onion routed flows are comprised of a source and destination flow layer address, a flow tag (an identifier to mark a distinct flow), and a pivot that each is using in common which acts as our analog to an ipv6 flow label, see rfc6437. 

## Public Functions Documentation

### function ToString

```cpp
std::string ToString() const
```


### function operator==

```cpp
bool operator==(
    const FlowInfo & other
) const
```


## Public Attributes Documentation

### variable src

```cpp
FlowAddr src;
```

source and destination addresses we associate with this flow. 

### variable dst

```cpp
FlowAddr dst;
```


### variable flow_tags

```cpp
std::set< FlowTag > flow_tags;
```

to be replaced by a std::optional<FlowTag>. 

all flow tags we are using on this flow right now. 


### variable mtu

```cpp
uint16_t mtu {default_flow_mtu};
```

mtu between src and dst. 

-------------------------------

Updated on 2023-04-27 at 04:17:17 +0000