---
title: llarp::layers::flow::FlowStateInfo
summary: immutable snapshot of a flow's state. 

---

# llarp::layers::flow::FlowStateInfo



immutable snapshot of a flow's state. 


`#include <flow_state.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[FlowStateInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowStateInfo.md#function-flowstateinfo)**(const FlowState_Pimpl & ) |
| bool | **[paths_aligned](Classes/structllarp_1_1layers_1_1flow_1_1FlowStateInfo.md#function-paths-aligned)**() const<br>returns true if we have paths that are aligned to the right place on the network to send to the remote.  |
| bool | **[requires_authentication](Classes/structllarp_1_1layers_1_1flow_1_1FlowStateInfo.md#function-requires-authentication)**() const<br>returns true if we are to do authentication with the remote.  |
| FlowAuthPhase | **[auth_phase](Classes/structllarp_1_1layers_1_1flow_1_1FlowStateInfo.md#function-auth-phase)**() const<br>get the phase we are in with auth.  |
| bool | **[established](Classes/structllarp_1_1layers_1_1flow_1_1FlowStateInfo.md#function-established)**() const<br>returns true if we have an established session for sending traffic over to the remote.  |

## Public Functions Documentation

### function FlowStateInfo

```cpp
explicit FlowStateInfo(
    const FlowState_Pimpl & 
)
```


### function paths_aligned

```cpp
bool paths_aligned() const
```

returns true if we have paths that are aligned to the right place on the network to send to the remote. 

### function requires_authentication

```cpp
bool requires_authentication() const
```

returns true if we are to do authentication with the remote. 

### function auth_phase

```cpp
FlowAuthPhase auth_phase() const
```

get the phase we are in with auth. 

### function established

```cpp
bool established() const
```

returns true if we have an established session for sending traffic over to the remote. 

any authentication has completed and accepted. 


-------------------------------

Updated on 2023-04-27 at 04:17:17 +0000